unit Demopas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Printers;

type
  TfrmDemo = class(TForm)
    btnBMP: TButton;
    btnWMF: TButton;
    btnCopy: TButton;
    btnPrint: TButton;
    btnClose: TButton;
    PrintDialog1: TPrintDialog;
    procedure btnBMPClick(Sender: TObject);
    procedure btnWMFClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

function BCCopyToClipboard(): boolean;
         stdcall; far; external 'BarcodeWin32.dll' name 'BCCopyToClipboard'

function BCSaveAsBMP(FileName: PChar): boolean;
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSaveAsBMP'

function BCSaveAsWMF(FileName: PChar): boolean;
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSaveAsWMF'

procedure BCRender(handle: HDC; x: Integer; y: Integer)
          stdcall; far; external 'BarcodeWin32.dll' name 'BCRender'

procedure BCGetActualSize(ScreenIsTarget: boolean; TargetHDC: HDC;
			  var ActualWidth: longint; var ActualHeight: longint)
          stdcall; far; external 'BarcodeWin32.dll' name 'BCGetActualSize'

procedure BCSetBackColor(red: integer; green: integer; blue:integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSetBackColor'

procedure BCSetBarColor(red: integer; green: integer; blue:integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSetBarColor'

procedure BCSetDefault(); stdcall; far; external 'BarcodeWin32.dll' name 'BCSetDefault'

procedure BCSetMessage(message: PChar);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSetMessage'

procedure BCSet2ndMessage(SecondMessage: PChar);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSet2ndMessage'

procedure BCSetSize(width: Integer; height: Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSetSize'

procedure BCFontInfo(FontName: PChar; FontSize: Integer; Bold: boolean; Italic: boolean);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCFontInfo'

procedure BCSupplementInfo(SupplementType: Integer; Supplement: Pchar; Separation: double);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCSupplementInfo'

procedure BCTextInfo(ShowText: boolean; CheckDigit: boolean; CheckDigitToText: boolean);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCTextInfo'

procedure BCUPCESystem(SystemType: Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCUPCESystem'

procedure BCConfigure(SymbologyType: Integer; BarHeight: double;
                      NarrowBarWidth: double; Wide2NarrowRatio: double;
                      Orientation: Integer; BorderWidth: double);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCConfigure'

procedure BCCodaBarInfo(StartChar: Integer; EndChar:Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCCodaBarInfo'

procedure BCMicroQRCode(version: Integer; level:Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCMicroQRCode'

procedure BCMicroPDF417(columns: Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCMicroPDF417'

procedure BCCodeOne(version: Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCCodeOne'

procedure BCBearerBar(style: Integer);
          stdcall; far; external 'BarcodeWin32.dll' name 'BCBearerBar'

implementation

{$R *.dfm}

procedure TfrmDemo.btnBMPClick(Sender: TObject);
var
    ActualWidth, ActualHeight: longint;
    BarcodeType, Orientation: Integer;
begin
    // choose the default configurations for the barcode
    BCSetDefault();

    // message
    BCSetMessage('12345678');

    // bar color
    BCSetBarColor(255, 0, 0);

    // background color
    BCSetBackColor(255, 255, 255);

    BarcodeType := 4;
    Orientation := 0;
    BCConfigure(BarcodeType, 3.5, 0.08, 2.2, Orientation, 0.07);

    // text message related info
    BCTextInfo(true, false, false);

    // font info
    BCFontInfo('Arial', 20, false, false);

    if BarcodeType = 2 then
        // CodeBar
        BCCodaBarInfo(0, 1);

    if BarcodeType = 58 then
        // UPC-E
        BCUPCESystem(1);

    if BarcodeType = 25 then
        // GS1 Databar 14 Composite
        BCSet2ndMessage('This is the secondary message');

    if BarcodeType = 37 then
        // Interleaved 2 0f 5
        BCBearerBar(1);

    if BarcodeType = 89 then
        // Code One
        BCCodeOne(2);

    if BarcodeType = 90 then
        // Micro PDF417
        BCMicroPDF417(4);

    if BarcodeType = 91 then
        // Micro QRCode
        BCMicroQRCode(3, 2);

    // if you are using the supplement, provide the supplement info here
    // otherwise ignore this line
    BCSupplementInfo(1, '12', 0.6);

    // get actual barcode width and height
    // render the barcode onto computer screen
    BCGetActualSize(true, 0, ActualWidth, ActualHeight);

    // image size = barcode size + extra space
    if (Orientation = 0) or (Orientation = 2) then
        BCSetSize(ActualWidth + 20, ActualHeight + 50)
    else
        BCSetSize(ActualHeight + 50, ActualWidth + 20);

    BCSaveAsBMP('c:\BC.bmp');

end;

procedure TfrmDemo.btnWMFClick(Sender: TObject);
var
    ActualWidth, ActualHeight: longint;
    BarcodeType, Orientation: Integer;
begin
    // choose default configurations for the barcode
    BCSetDefault();

    // message
    BCSetMessage('12567');

    // bar color
    BCSetBarColor(0, 0, 0);

    // background color
    BCSetBackColor(255, 255, 255);

    BarcodeType := 12;
    Orientation := 3;
    BCConfigure(BarcodeType, 3.5, 0.08, 2.2, Orientation, 0.07);

    // Text message related info
    BCTextInfo(true, false, false);

    // font info
    BCFontInfo('Arial', 16, false, true);

    // if you are using the supplement, provide the supplement info here
    // otherwise ignore this line
    BCSupplementInfo(1, '12', 0.6);

    // get actual barcode width and height
    // render barcode onto computer screen
    BCGetActualSize(true, 0, ActualWidth, ActualHeight);

    // image size = barcode size + extra space
    if (Orientation = 0) or (Orientation = 2) then
        BCSetSize(ActualWidth + 20, ActualHeight + 50)
    else
        BCSetSize(ActualHeight + 50, ActualWidth + 20);

    BCSaveAsWMF('c:\\BC.wmf');
end;

procedure TfrmDemo.btnCopyClick(Sender: TObject);
var
    ActualWidth, ActualHeight: longint;
begin
    // choose the default configurations for the barcode
    BCSetDefault();

    // get the actual barcode width and height
    // render the barcode onto computer screen
    BCGetActualSize(true, 0, ActualWidth, ActualHeight);

    // image size = barcode size + extra space
    BCSetSize(ActualWidth + 20, ActualHeight + 50);

    // send the image to the clipboard
    BCCopyToClipboard();
end;

procedure TfrmDemo.btnPrintClick(Sender: TObject);
var
    ActualWidth, ActualHeight: longint;
    BarcodeType, Orientation: Integer;
begin
   if PrintDialog1.Execute then
   begin
      // send a print job to the printer
      Printer.BeginDoc;

      // choose the default configurations for the barcode
      BCSetDefault();

      // message
      BCSetMessage('12567');

      // bar color
      BCSetBarColor(0, 0, 0);

      // background color
      BCSetBackColor(255, 255, 255);

      BarcodeType := 12;
      Orientation := 0;
      BCConfigure(BarcodeType, 3.5, 0.08, 2.2, Orientation, 0.08);

      // get the actual barcode width and height
      // render a barcode onto printer
      BCGetActualSize(false, Printer.Handle, ActualWidth, ActualHeight);

      // image size = barcode size + extra space
      BCSetSize(ActualWidth + 300, ActualHeight + 200);

      // print the barcode at the point(100, 500)
      BCRender(Printer.Handle, 100, 500);

      // end the current print job
      Printer.EndDoc;
   end;
end;

procedure TfrmDemo.btnCloseClick(Sender: TObject);
begin
   // shut down the application
   Application.Terminate;
end;

end.
